
#include "LinkedList.h"

/*	 Ʈ ʱȭϴ Լ	*/
void InitLinkedList(LinkedList* pList)
{
	pList->pHead = NULL;
}

/*	带 ϰ 带 ȯϴ Լ	*/
Node* CreateNode(LinkedListData lData)
{
	Node* pNewNode = malloc(sizeof(Node));

	pNewNode->pNext = NULL;
	pNewNode->lData = lData;

	return pNewNode;
}

/*	 ϳ ϴ Լ	*/
void DeleteNode(Node* pNode)
{
	if (pNode != NULL)
	{
		/*	   ͸ 	*/
		printf("%d ", pNode->lData);
		free(pNode);
	}
}

/*	ü 带 ϴ Լ	*/
void DeleteAllNode(Node** pHead)
{
	Node* pNext = NULL;

	/*	 Լ Ż 	*/
	if (*pHead == NULL)
		return;

	pNext = (*pHead)->pNext;

	DeleteNode(*pHead);

	DeleteAllNode(&pNext);
}

/*	带   ߰ϴ Լ	*/
void AppendNode(Node** pHead, Node* pNode)
{
	Node* pCur = NULL;

	/*	(*pHead) NULL 쿡 Ͱ     */
	if (*pHead == NULL)
		*pHead = pNode;
	
	/*	(*pHead) NULL ƴ 쿡 Ͱ ִ    */
	else
	{
		pCur = *pHead;

		/*	pCur ġ   ̵ Ų.	*/
		while (pCur->pNext != NULL)
			pCur = pCur->pNext;

		/*	ο 带 	*/
		pCur->pNext = pNode;
	}
}

/*	͸   ߰ϴ Լ	*/
void AddData(Node** pHead, LinkedListData lData)
{
	Node* pNewNode = CreateNode(lData);

	AppendNode(pHead, pNewNode);
}

/*	   ϴ Լ	*/
void DisplayAllNode(Node** pHead)
{
	Node* pCur = *pHead;

	if (pCur == NULL)
	{
		printf(" Ͱ ϴ.\n");
		return;
	}

	while (pCur != NULL)
	{
		printf("%d ", pCur->lData);
		
		pCur = pCur->pNext;	//	pCur   ̵
	}
	printf("\n");
}

/*	   ϴ Լ	*/
int GetAllNodeCount(Node** pHead)
{
	Node* pCur = *pHead;
	int nCount = 0;

	while (pCur != NULL)
	{
		nCount += 1;

		pCur = pCur->pNext;
	}

	return nCount;
}

/*
	Ʈ  ٲٴ Լ
	ϰ   Ʈ  ̴.
*/
Node* Reverse(Node* pHead)
{
	Node* p, * q, * r;
	p = pHead;	//	p  ó  
	q = NULL;	//	q   

	while (p != NULL)
	{
		r = q;	//	r   

		q = p;	//	r q, q p ʷ 󰣴.

		p = p->pNext;

		q->pNext = r;	//	q pNext  ٲ۴.
	}
	return q;	//	q   Ʈ  
}	
